
// ****************************************************************************
// * iniHisto
// ****************************************************************************
void iniHisto(void) @ -5.0 {
  const ℝ binMaxf=(ℝ)binMax;
  info()<<"[7;37m[iniHisto][m";
  //info()<<"binMaxf="<<binMaxf;
  for(int i=0;i<binMax;i+=1){
    const ℝ ir=(ℝ)i;
    const ℝ Θbinmax = 4.0*√(4.0*option_νδt); // 4.0 * la vitesse thermique (arbitraire)
    histo[i]=0.0;
    Θbinning[i]=Θbinmax*ir/binMaxf;
    //info()<<"binning["<<i<<"]="<<Θbinning[i]<<", ir="<<ir;
  }      
}


// ****************************************************************************
// * diagnosticSpectrum
// ****************************************************************************
void diagnosticSpectrum(ℝ θ){
  ℕ j=0;
  while(θ>Θbinning[j]){
    j+=1;
    if (j==binMax) return;
  }
  histo[j]+=1;
}


// ****************************************************************************
// * diagnosticSpectrum
// ****************************************************************************
void dumpSpectrum(void){
  ℝ sum=0.0;
  for(int i=0;i<binMax;i+=1)
    sum+=histo[i];
  for(int i=0;i<binMax-1;i+=1){
    const ℝ value = histo[i]/sum;
    const ℝ x = ½*(Θbinning[i]+Θbinning[i+1]);
    const ℝ y = value/(Θbinning[i+1]-Θbinning[i]);
    printf(" %f",y);
    histoData << "\t" << x << "\t" << y;
  }
  printf("\n[7m[tstForQuit] Sum=%f[m\n\r",sum);
  //assert(sum==(ℝ)NABLA_NB_PARTICLES);
}
