///////////////////////////////////////////////////////////////////////////////
// NABLA - a Numerical Analysis Based LAnguage                               //
//                                                                           //
// Copyright (C) 2014~2016 CEA/DAM/DIF                                       //
// IDDN.FR.001.520002.000.S.P.2014.000.10500                                 //
//                                                                           //
// Contributor(s): CAMIER Jean-Sylvain - Jean-Sylvain.Camier@cea.fr          //
//                                                                           //
// This software is a computer program whose purpose is to translate         //
// numerical-analysis specific sources and to generate optimized code        //
// for different targets and architectures.                                  //
//                                                                           //
// This software is governed by the CeCILL license under French law and      //
// abiding by the rules of distribution of free software. You can  use,      //
// modify and/or redistribute the software under the terms of the CeCILL     //
// license as circulated by CEA, CNRS and INRIA at the following URL:        //
// "http://www.cecill.info".                                                 //
//                                                                           //
// The CeCILL is a free software license, explicitly compatible with         //
// the GNU GPL.                                                              //
//                                                                           //
// As a counterpart to the access to the source code and rights to copy,     //
// modify and redistribute granted by the license, users are provided only   //
// with a limited warranty and the software's author, the holder of the      //
// economic rights, and the successive licensors have only limited liability.//
//                                                                           //
// In this respect, the user's attention is drawn to the risks associated    //
// with loading, using, modifying and/or developing or reproducing the       //
// software by the user in light of its specific status of free software,    //
// that may mean that it is complicated to manipulate, and that also         //
// therefore means that it is reserved for developers and experienced        //
// professionals having in-depth computer knowledge. Users are therefore     //
// encouraged to load and test the software's suitability as regards their   //
// requirements in conditions enabling the security of their systems and/or  //
// data to be ensured and, more generally, to use and operate it in the      //
// same conditions as regards security.                                      //
//                                                                           //
// The fact that you are presently reading this means that you have had      //
// knowledge of the CeCILL license and that you accept its terms.            //
//                                                                           //
// See the LICENSE file for details.                                         //
///////////////////////////////////////////////////////////////////////////////

void syncBeforeGeom(void) @ -9.9{
  synchronize(cell_mass_center);
}

void syncBeforeAleph(void) @ 9.9{
  synchronize(interior_primal_c_sp);
  synchronize(interior_primal_c_sq);
  synchronize(interior_dual_c_sd);
  synchronize(interior_dual_c_se);
  synchronize(interior_dual_c_lm);
  synchronize(interior_dual_c_sl);
  synchronize(interior_dual_c_sm);
  synchronize(interior_dual_face_uid);
  synchronize(interior_dual_face_swap);
  synchronize(interior_dual_c_jk);
  synchronize(interior_dual_c_sj);
  synchronize(interior_dual_c_sk);

  synchronize(interior_dual_c_sd_q);
  synchronize(interior_dual_c_se_q);
  synchronize(interior_dual_c_lm_q);
  synchronize(interior_dual_c_sl_q);
  synchronize(interior_dual_c_sm_q);
  synchronize(interior_dual_c_jk_q);
  synchronize(interior_dual_c_sj_q);
  synchronize(interior_dual_c_sk_q);
  synchronize(interior_dual_face_uid_q);
  synchronize(interior_dual_face_swap_q);

  synchronize(interior_dual_c_sd_p);
  synchronize(interior_dual_c_se_p);
  synchronize(interior_dual_c_lm_p);
  synchronize(interior_dual_c_sl_p);
  synchronize(interior_dual_c_sm_p);
  synchronize(interior_dual_c_jk_p);
  synchronize(interior_dual_c_sj_p);
  synchronize(interior_dual_c_sk_p);
  synchronize(interior_dual_face_uid_p);
  synchronize(interior_dual_face_swap_p);

}


void syncAfterSolve(void) @ 30.0 {
  synchronize(cell_θ);
  synchronize(face_θ);
  synchronize(node_θ);
}
